/* UW9 - Operator Services uw-src/collide.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

void collide(char *who, char *rest)
{
   FILE *rfile;
   char *helpname, *nwho, tmp[100],*user, *host, *reason, *usernum, *dwho;
    struct nickinfo *nick;

   nwho = nick2num(who);
   helpname = get_command_name("collide");
   if(rest == NULL || rest[0] == '\0' || strchr(rest,'!') != NULL)
   {
      do_help(who, helpname);
      return;
   }
   if((user = strchr(rest, ' ')) != NULL)  *user++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :You must specify a user id, read help\n", bot.nick, nwho);
      return;
   }
   if((host = strchr(user, ' ')) != NULL)  *host++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :You must specify a host, read help\n", bot.nick, nwho);
      return;
   }
   if(strchr(user, '@'))
   {
      do_help(who, helpname);
      return;
   }
   if((reason = strchr(host, ' ')) != NULL) *reason++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :You must specify a COLLIDE reason, read help\n", bot.nick, nwho);
      return;
   }
   if(strchr(host, '@'))
   {
      do_help(who, helpname);
      return;
   }
   nick = return_nickinfo(rest);
   if(nick == NULL)
   {
      send_to_server(":%s NOTICE %s :that user is not online\n", bot.nick, nwho);
       return;
    }
   if(*user == '~') *user++;
   if(!strcasecmp(user, nick->user))
      if(!strcasecmp(host, nick->host))
      {
        send_to_server(":%s NOTICE %s :cannot use the exact same user@host as target\n", bot.nick, nwho);
        return;
      }
   dwho = nick2num(rest);
   delete_node(dwho);
   usernum=get_free_usernum(rest);
   send_to_server("%c NICK %s 1 780000000 %s %s DQx8MG %s :%s\n", convert2y[server_num], rest, user, host, usernum, reason);
   add_nickinfo(rest, user, host, "DQx8MG", usernum, myserver, reason);
   send_to_server(":%s NOTICE %s :Cloned user %s!%s@%s\n", bot.nick, nwho, rest, user, host);
}

void clone(char *who, char *rest)
{
   FILE *rfile;
   char *nick, *nwho, tmp[100],*user, *host, *reason, *usernum, *helpname;

   helpname = get_command_name("clone");
   nwho = nick2num(who);
   if(rest == NULL)
   {
      send_to_server(":%s NOTICE %s :I believe you need to review the help\n", bot.nick, nwho);
      return;
   }
   if(rest[0] == '\0')
   {
      send_to_server(":%s NOTICE %s :I believe you need to review the help\n", bot.nick, nwho);
      return;
   }
   if(strchr(rest,'!') != NULL)
   {
      send_to_server(":%s NOTICE %s :Improper Syntax, Please Read Help\n", bot.nick, nwho);
      return;
   }
   if((nick = strchr(rest, ' ')) != NULL)  *nick++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :You must specify a nick, read help\n", bot.nick, nwho);
      return;
   }
   if((user = strchr(nick, ' ')) != NULL)  *user++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :You must specify a user id, read help\n", bot.nick, nwho);
      return;
   }
   if((host = strchr(user, ' ')) != NULL)  *host++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :You must specify a host, read help\n", bot.nick, nwho);
      return;
   }
   if(strchr(user, '@'))
   {
      do_help(who, helpname);
      return;
   }
   if((reason = strchr(host, ' ')) != NULL) *reason++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :You must specify a channel , read help\n", bot.nick, nwho);
      return;
   }
   if(strchr(host, '@'))
   {
      do_help(who, helpname);
      return;
   }
   usernum=get_free_usernum(rest);
   send_to_server("%c NICK %s 1 780000000 %s %s DQx8MG %s :%s\n", convert2y[server_num], nick, user, host, usernum, reason);
   add_nickinfo(nick, user, host, "DQx8MG", usernum, myserver, reason);
   send_to_server(":%s JOIN %s\n", nick, rest);
   add_joininfo(rest, usernum, FALSE);
   send_to_server(":%s NOTICE %s :Cloned user %s!%s@%s\n", bot.nick, nwho, nick, user, host);
}

void clone_part(char *who, char *rest)
{
   char *reason, *nwho, *nick;

   if(*rest != '#')
   {
      send_to_server(":%s NOTICE %s :must have a channel\n", bot.nick, nwho);
      return;
   }
   if((nick = strchr(rest, ' ')) != NULL)  *nick++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :must have a nick\n", bot.nick, nwho);
      return;
   }
   if((reason = strchr(nick, ' ')) != NULL)  *reason++ = '\0';
   else
   {
      send_to_server(":%s PART %s\n", nick, rest);
      return;
   }
   send_to_server(":%s PART %s :%s\n", nick, rest, reason);
}

void clone_join(char *who, char *rest)
{
   char *nick, *nwho;

   if(*rest != '#')
   {
      send_to_server(":%s NOTICE %s :must have a channel\n", bot.nick, nwho);
      return;
   }
   if((nick = strchr(rest, ' ')) != NULL)  *nick++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :must have a nick\n", bot.nick, nwho);
      return;
   }
   send_to_server(":%s JOIN :%s\n", nick, rest);
}

void clone_quit(char *who, char *rest)
{
   char *reason, *nwho;

   if((reason = strchr(rest, ' ')) != NULL)  *reason++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :must have a reason\n", bot.nick, nwho);
      return;
   }
   send_to_server(":%s QUIT :%s\n", rest, reason);
}

void clone_say(char *who, char *rest)
{

   char *reason, *nwho, *nick;

   nwho = nick2num(who);
   if((nick = strchr(rest, ' ')) != NULL)  *nick++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :must have a nick\n", bot.nick, nwho);
      return;
   }
   if((reason = strchr(nick, ' ')) != NULL)  *reason++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :must have add a sentance\n", bot.nick, nwho);
      return;
   }
   send_to_server(":%s PRIVMSG %s :%s\n", nick, rest, reason);
}
