/* UW9 - Operator Services src/add_badchan.c
 * UW8.0, UW8.1 and UW9.0 Copyright  1998-1999 Chris Birch(IRCore)
 */
char *dectoip(int);
void clone_ctcp_dcc(char *, char *);
void clone_ctcp_time(char *, char *);
void clone_ctcp_userinfo(char *, char *);
void clone_ctcp_clientinfo(char *, char *);
void clone_part(char *, char *);
void clone_join(char *, char *);
void clone_quit(char *, char *);
void clone_say(char *, char *);
void credits(char *, char *);
void copyright(char *, char *);
void clearchan(char *, char *);
int bancmp1(char *, char *);
void list_it(char *, char *);
char *mkpass(char *, char *);
void get_crypt(char *, char *);
void settime();
void invitethem(char *, char *);
void refresh_glines();
char *getghost(char *);
void broadcast(char *, char *);
void chankill(char *, char *);
void clone(char *, char *);
void collide(char *, char *);
void block(char *, char *);
void opermsg(char *, char *);
void add_prot(char *, char *);
void add_trust(char *, char *);
void del_prot(char *, char *);
void del_trust(char *, char *);
void add_bad(char *, char *);
void add_kill(char *, char *);
void add_secret(char *, char *);
void del_bad(char *, char *);
void del_bad(char *, char *);
void del_kill(char *, char *);
void del_secret(char *, char *);
void write_badinfo();
void write_secretinfo();
void hostchk(char *, char *);
void whoison(char *, char *);
void ison(char *, char *);
int check_gline(char *);
void do_gline(char *, char *);
void hostkill(char *, char *);
void do_ungline(char *, char *);
void unjupe(char *, char *);
void unreserve(char *, char *);
void jupe(char *, char *);
void reserve(char *, char *);
char *get_ban_mask(char *);
char *get_time(long);
char *get_command_rname(char *);
char *get_command_name(char *);
void showdisabled(char *, char *);
void disablecomm(char *, char *);
void enablecomm(char *, char *);
void change_comm_name(char *, char *);
void change_comm_level(char *, char *);
void cswall(char *, char *);
void invite(char *, char *);
void kick_all(char *, char *);
void kick_ban_all(char *, char *);
void nickban(char *, char *);
void unban(char *, char *);
int compare(const void *, const void *);
extern char *collapse(char *pattern);
extern int mmatch(const char *old_mask, const char *new_mask);
extern int match(const char *ma, const char *na);
extern int mycmp(const char *s1, const char *s2);
extern int myncmp(const char *str1, const char *str2, int n);
void operlist(char *, char *);
void mode(char *, char *);
void showcommands(char *, char *);
int check_level_help(char *, char *, char *);
int check_level(char *, char *);
void show_map(char *,char *);
void last_seen(char *, char *);
void suspend(char *, char *);
void admin(char *, char *);
int add_oper_addrinfo(char *, char *);
void whois(char *, char *);
void parse_eoburst();
void parse_eob_ack();
void lastseen(char *, char *);
char *conv_char(char *);
char *conv_oct(char *);
void opers_invite(char *, char *);
void get_ip(char *, char *);
void get_dns(char *, char *);
void add_modeinfo(char *, char *, char *);
void add_templist(char *);
void parse_create(char *, char *);
void delete_cnode(char *, char *);
void serv_unused(char *);
void serv_used(char , char *);
void delete_usernum(char *);
char *list_bans(char *);
char *list_modes(char *);
char *num2serv(char);
char *nick2num(char *);
char *swap_host(char *, char *);
char *num2nick(char *);
char *get_free_usernum(char *);
char *get_usernum(char *);
char get_free_servnum(char *, char );
int is_serv(char *);
void parse_join(char *, char *);
void parse_ping(char *, char *);
int comp(char *, char *, int);
void flood_user(char *, char *);
void parse_join(char *, char *);
void parse_ping(char *, char *);
char *get_free_usernum(char *);
char *get_usernum(char *);
void load_nums();
void parse_005();
void clone_ctcp_finger(char *, char *);
void clone_ctcp_ping(char *, char *, char *);
void ctcp_ping(char *, char *);
void ctcp_gender(char *, char *);
void ctcp_version(char *, char *);
void inviteme(char *, char *);
void parse_pong(char *, char *);
void parse_server(char *, char *);
void parse_action(char *, char *);
void parse_kill(char *, char *);
void parse_nick(char *, char *);
void parse_kick(char *, char *);
void parse_privmsg(char *, char *);
void parse_mode(char *, char *);
void parse_pass(char *, char *);
void parse_quit(char *, char *);
void parse_topic(char *, char *);
void parse_squit(char *, char *);
void parse_away(char *, char *);
void parse_367(char *, char *);
void parse_353(char *, char *);
void parse_324(char *, char *);
void parse_332(char *, char *);
void parse_part(char *, char *);
void write_all_files();
void register_channel(char *, char *);
void opregister_channel(char *, char *);
void unregister_channel(char *, char *);
void set_url(char *, char *);
void make_welcome(char *, char *);
void set_welcome(char *, char *);
void set_voice(char *, char *);
void purge_flag(char *, char *);
int check_purge_flag(char *);
void authorize(char *, char *);
void authop(char *, char *);
void dauthorize(char *who, char *rest);
void set_default_topic(char *, char *);
void set_default_modes(char *, char *);
void strip_period(char *);
void del_wild(char *);
void strip_slash(char *);
void strip_bslash(char *);
void delete_channel_node(char *);
int change_password(char *, char *, char *, char *);
void say_text(char *, char *);
void refresh_registered();
void rehash();
void check_channel_purge_time();
void do_action(char *, char *);
void purge_channel(char *);
void replace_node(char *, char *);
int delete_addrnode(char *, char *);
void replace_onode(char *, char *, int);
void delete_unode(char *);
void write_oper();
void topic(char *, char *);
void file_error(char *);
void delete_node(char *);
void delete_snode(char *);
void free_nicklist();
void free_maplist();
void free_modelist();
void set_ownername(char *, char *);
void set_desc(char *, char *);
void set_chmodelvl(char *, char *);
void set_owneremail(char *, char *);
void set_strictop(char *, char *);
void set_noban(char *, char *);
void set_operop(char *, char *);
void set_noops(char *, char *);
void set_stay(char *, char *);
void set_banlevel(char *, char *);
void load_channels();
void clearban(char *, char *);
void masskill(char *, char *);
void send_denied_msg(char *);
void add_userinfo(char *, int, int, long);
void add_nickinfo(char *, char *, char *,char *, char *, char *, char *);
void show_access(char *, char *);
void reinit();
void ban(char *, char *);
void show_uptime(char *, char *);
void load_operlist();
int is_ip(char *);
int is_num(char *);
char *convert_addr(char *, char *);
int bancmp(const char *, const char *);
int check_chan(char *);
void clearmode(char *, char *);
void deopall(char *, char *);
void opall(char *, char *);
void moderate(char *, char *);
void unmoderate(char *, char *);
void new_password(char *, char *);
void set_topicnumber();
int set_chaninfo(char *, char *, int);
struct regsinfo *is_registered(char *);
int get_command_level(char *);
struct operinfo *return_maskinfo(char *);
struct operinfo *return_operinfo(char *);
struct nickinfo *return_nickinfo(char *);
struct operinfo *ret_oper_level(char *);
struct adderinfo *ret_oper_addrinfo(char *, char *);
struct operinfo *ret_oper_operinfo(char *);
struct nickinfo *return_chaninfo(char *, char *);
int check_access(char *, char *, int, char *);
char *getuserhost(char *);
char *getnickuserhost(char *);
int check_flood(char *), find_flood(char *);
void add_to_flood_list(char *), reset_flood();
char strlwr(char *), *strupr(char *);
char translate_esc(char *, char *);
char *date();
char *bottime();
int get_connection(char *, int), readln(), writeln(char *);
int wcmp(char *, char *);
int writelns(int, char *);
int read_from_socket(int, char *);
int send_to_socket(int, char *, ...);
int send_to_server(char *, ...);
void sig_pipe(), sig_bus();
void log(char *, char *, ...), load_cfg();
void command_log(char *, char *, char *);
void parse(char *);
void join_channels();
void join_msgchan();
int reconnect();
void debug(char *, ...);
void set_fds(), sendping();
void strip_newline(char *), reinit_bot(), init_bot(), sig_alrm();
void kick_ban(char *, char *);
void deop(char *, char *);
void die(char *, char *);
void sig_segv();
void trailing_blanks(char *);
void giveop(char *, char *);
int chan_check(char *, char *);
int check(char *, char *);
void join(char *, char *), part(char *, char *);
void do_help(char *, char *);
void help(char *, char *);
void show_chaninfo(char *, char *);
void default_topic(char *);
void show_welcome(char *, char *);
void default_modes(char *);
void kick_user(char *, char *);
void parse_server_msg(fd_set *read_fds);
void free_chaninfo();
void add_user(char *, char *);
void delete_user(char *, char *);
void mod_oper(char *, char *);
void add_oper(char *, char *);
void delete_oper(char *, char *);
void set_flood_rate(char *, char *);
void parse_admin(char *, char *);
void parse_stats(char *, char *);
void parse_version(char *, char *);
void parse_burst(char *, char *);
