/* UW9 - Operator Services uw-src/join_part.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

void join(char *who, char *rest)
{
   char *usernum, *chan, *nwho;

   if(!rest) return;
   nwho = nick2num(who);
   chan = strtok(rest, " ");
   if(*chan == '+' || *chan == '&') return;
   if(chan_check(chan, who) == -1) return;
   usernum=get_usernum(bot.nick);
   send_to_server(":%s JOIN %s\n", bot.nick, rest);
   send_to_server(":%s MODE %s +o %s\n", myserver, rest, usernum);
}

void part(char *who, char *rest)
{
   char *nwho, *chan;

   if(!rest) return;
   chan = strtok(rest, " ");
   if(chan_check(chan, who) == -1) return;
   nwho=nick2num(who);
   send_to_server(":%s PART %s\n", bot.nick, rest);
}
