/* UW9 - Operator Services uw-src/load_cfg.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

void load_cfg()
{
   FILE *fp;
   char buffer[MAXDEF], *field;
   buffer[0]='\0';
   ymsgchan = 0;
   if((fp = fopen(CFG_FILE, "r")) == NULL) 
   {
      file_error(CFG_FILE);
      return;
   }
   while(fgets(buffer, MAXDEF, fp)) 
   {
      if(buffer[0] == '*' || buffer[0] == '\n') continue;
      strip_newline(buffer);
      trailing_blanks(buffer);
      if(field = strchr(buffer, ' ')) *field++ = '\0';
      if(!strcmp(buffer, "DEFAULT_SERVER") && field != NULL) 
      {
	 strcpy(bot.server, field);
      }
      if(!strcmp(buffer, "DEFAULT_PORT") && field != NULL) 
      {
	 bot.port = atoi(field);
      }
      if(!strcmp(buffer, "SERVERS"))
      {
	 while(fgets(buffer, MAXDEF, fp)[0] != '-')
	 {
	    if(buffer[0] == '*') continue;
	    strcpy(servers[no_servers].name, strtok(buffer, " \n"));
	    servers[no_servers].port = atoi(strtok(NULL, " \n"));
	    no_servers++;
	 }
      }
      if(!strcmp(buffer, "ACCESS_DENIED") && field != NULL) 
      {
	 strcpy(denied_msg, field);
      }
      if(!strcmp(buffer, "FLOOD_RATE") && field != NULL) 
      {
	 flood_rate = atoi(field);
      }
      if(!strcmp(buffer, "FLOOD_TIME") && field != NULL) 
      {
	 flood_time = atoi(field);
      }
      if(!strcmp(buffer, "RESET_TIME") && field != NULL) 
      {
	 reset_time = atoi(field);
      }
      if(!strcmp(buffer, "MSG_CHAN") && field != NULL && *field == '#') 
      {
         ymsgchan = 1;
	 strcpy(msg_chan, field);
      }
      if(!strcmp(buffer, "NETPASS") && field != NULL) 
      {
	 strcpy(netpass, field);
      }
      if(!strcmp(buffer, "MYSERVER") && field != NULL) 
      {
	 strcpy(myserver, field);
      }
      if(!strcmp(buffer, "MYMODES") && field != NULL) 
      {
	 strcpy(mymodes, field);
      }
      if(!strcmp(buffer, "REASON") && field != NULL) 
      {
	 strcpy(reason, field);
      }
      if(!strcmp(buffer, "IRCNAME") && field != NULL) 
      {
	 strcpy(ircname, field);
      }
      if(!strcmp(buffer, "IRCUSER") && field != NULL) 
      {
	 strcpy(ircuser, field);
      }
      if(!strcmp(buffer, "MYHOST") && field != NULL) 
      {
	 strcpy(myhost, field);
      }
      if(!strcmp(buffer, "BOTNICK") && field != NULL) 
      {
	 strcpy(botnick, field);
      }
      if(!strcmp(buffer, "PID_FILE") && field != NULL) 
      {
	 strcpy(pid_file, field);
      }
      if(!strcmp(buffer, "QUIT_MSG") && field != NULL) 
      {
	 strcpy(quit_msg, field);
      }
      if(!strcmp(buffer, "CHANSERV_HOST") && field != NULL) 
      {
	 strcpy(chanhost, field);
      }
      if(!strcmp(buffer, "CHANSERV_NICK") && field != NULL) 
      {
	 strcpy(chanserv, field);
      }
      if(!strcmp(buffer, "SERVER_NUM") && field != NULL)
      {
	 server_num=atoi(field);
      }
      if(!strcmp(buffer, "MAXOPERLEVEL") && field != NULL)
      {
	 maxoperlevel=atoi(field);
      }
      if(!strcmp(buffer, "MAXNICKLEN") && field != NULL)
      {
	 maxnicklen=atoi(field);
      }
      if(!strcmp(buffer, "LOGGING") && field != NULL)
      {
	 logging=atoi(field);
      }
      if(!strcmp(buffer, "MAXCLONES") && field != NULL)
      {
	 maxclones=atoi(field);
      }
      if(!strcmp(buffer, "CLONEMSG") && field != NULL)
      {
	 clonemsg=atoi(field);
      }
      if(!strcmp(buffer, "COLOR") && field != NULL)
      {
         colorm=atoi(field);
      }
      if(!strcmp(buffer, "ADM_GLINE") && field != NULL)
      {
         adm_gline=atoi(field);
      }
      if(!strcmp(buffer, "KILLFLOOD"))
      {
         killflood=atoi(field);
      }
      if(!strcmp(buffer, "PRIVMSG"))
      {
         y_privmsg=atoi(field);
      }
      if(!strcmp(buffer, "BLOCK_TIME"))
      {
         blocktime=atol(field);
      }
   }
   fclose(fp);
}
