/* UW9 - Operator Services uw-src/oper_node_tools.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include <bot.h>

int delete_addrnode(char *nick, char *addr)
{
   struct operinfo *oper;
   struct adderinfo *current, *previous;

   oper = operhead;
   while(oper != NULL)
   {
      if(!strcasecmp(nick, oper->nick))
      {
	 current = oper->adderhead;
	 if(current->next == NULL) return 0;
	 while(current != NULL)
	 {
	    if(!strcasecmp(addr, current->address)) break;
	    else
	    {
	       previous = current;
	       current = current->next;
	    }
	 }
	 if(current == NULL) return 2;
	 else
	 {
	    if(current == oper->adderhead) oper->adderhead = oper->adderhead->next;
	    else previous->next = current->next;
	    free(current);
	    return 1;
	 }

	 }
	 oper = oper->next;
   }
   return 2;
}

void replace_onode(char *chan, char *numeric, int ops)
{
   struct nickinfo *nick;
   struct chaninfo *current;
   if(nickhead == NULL) return;
   nick = nickhead;
   while(nick != NULL)
   {
      if(!strcmp(numeric, nick->numeric))
      {
	 current = nick->chanhead;
	 while(current != NULL)
	 {
	    if(!strcasecmp(chan, current->channel))
	    {
	       current->is_ops = ops;
	       return;
	    }
	    current = current->next;
	 }
      }
      nick = nick->next;
   }
}

void replace_node(char *numeric, char *newnick)
{
   struct nickinfo *current;
   if(nickhead == NULL) return;
   current = nickhead;
   while(current != NULL)
   {
      if(!strcmp(numeric, current->numeric))
      {
	 strcpy(current->nick, newnick);
      }
      current = current->next;
   }
}

void delete_rnode(char *chan)
{
   struct roominfo *current, *previous;


   current = roomhead;
   while(current != NULL)
   {
      if(!strcasecmp(chan, current->channel)) break;
      else
      {
	 previous = current;
	 current = current->next;
      }
   }
   if(current == NULL) return;
   else
   {
      if(current == roomhead) roomhead = roomhead->next;
      else previous->next = current->next;
      free(current);
   }
}

void delete_unode(char *nick)
{
   struct operinfo *current, *previous;
   struct adderinfo *current1, *previous1, *tmp;

   current = operhead;
   while(current != NULL)
   {
      if(!strcasecmp(nick, current->nick)) break;
      else
      {
	 previous = current;
	 current = current->next;
      }
   }
   if(current == NULL) return;
   else
   {
      current1 = current->adderhead;
      while(current1 != NULL)
      {
	 if(current1 == current->adderhead) current->adderhead = current->adderhead->next;
	 else previous1->next = current1->next;
	 tmp=current1->next;
	 free(current1);
	 current1 = tmp;
      }
      if(current == operhead) operhead = operhead->next;
      else previous->next = current->next;
      free(current);
   }
}

   void delete_node(char *numeric)
   {
      struct nickinfo *current, *previous, *tmp;
      struct chaninfo *chan, *previous1, *tmp1;
      char *uhost, *who;

      current = nickhead;
      while(current != NULL)
      {
	 if(!strcmp(numeric, current->numeric)) break;
	 else
	 {
	    previous = current;
	    current = current->next;
	 }
      }
      if(current == NULL) return;
      else
      {
	 chan = current->chanhead;
	 while(chan != NULL)
	 {
	    if(chan == current->chanhead) current->chanhead = current->chanhead->next;
	    else previous1->next = chan->next;
	    tmp1 = chan->next;
            decroomcnt(chan->channel);
	    free(chan);
	    chan=tmp1;
	 }
	 if(current == nickhead) nickhead = nickhead->next;
	 else previous->next = current->next;
	 free(current);
	 number--;
	 return;
      }
   }

   void delete_cnode(char *chan, char *who)
   {
      struct nickinfo *nick;
      struct chaninfo *current, *previous;

      nick = nickhead;
      while(nick != NULL)
      {
	 if(!strcasecmp(who, nick->nick))
	 {
	    current = nick->chanhead;
	    while(current != NULL)
	    {
	       if(!strcasecmp(chan, current->channel)) break;
	       else
	       {
		  previous = current;
		  current = current->next;
	       }
	    }
	    if(current == NULL) return;
	    else
	    {
	       if(current == nick->chanhead) nick->chanhead = nick->chanhead->next;
	       else previous->next = current->next;
	       free(current);
               decroomcnt(chan);
	       return;
	    }
	 }
	 nick = nick->next;
      }
   }

   void delete_snode(char *server)
   {
      struct nickinfo *current;
      struct templist *temp;

      current = nickhead;
      while(current != NULL)
      {
	 if(!strcasecmp(server, current->server))
	 {
	    add_templist(current->numeric);
	 }
	 current = current->next;
      }
      temp = listhead;
      while(temp != NULL)
      {
	 delete_node(temp->channel);
	 temp = temp->next;
      }
      free_templist();
   }
