/* UW9 - Operator Services uw-src/parse.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include <bot.h>

void parse(char *line)
{
   int i = 0;
   char *sample = NULL, *nline = NULL, *cmd = NULL, *rest = NULL, *who = NULL, test[1000], *server = NULL, *botnum;
   char *samp1 = NULL, *samp2 = NULL, *samp3 = NULL, *samp4 = NULL, *samp5 = NULL, *samp6 = NULL, *ptr = NULL, *ptr1 = NULL, nrest[10000], logit[10000];
   char *nwho = NULL;
   int nick_server = 0, id = 0;

   trailing_blanks(line);
   if(strlen(line) > 524)
   {
      return;
   }
   strcpy(test, line);
   if(is_serv(test) || *line == ':')
   {
      if (!strncmp(line,":SERVER",7))
	 nick_server = 1;
      line++;
      if(cmd = strchr(line, ' ')) *cmd++ = '\0';
      who = line;
      if(rest = strchr(cmd, ' ')) *rest++ = '\0';
      else
      {
	 if(strcmp(cmd, "EOB_ACK") && strcmp(cmd, "END_OF_BURST") && strcmp(cmd, "AWAY"))
	 {
	    if(who = strchr(line, ' ')) *who++ = '\0';
	    cmd = line;
	 }
	 rest = NULL;
      }
   }
   else
   {
      strcpy(test, line);
      who=strtok(test, " ");
      if(strcasecmp(who, "PASS"))
      {
	 if(cmd = strchr(line, ' ')) *cmd++ = '\0';
	 if(rest = strchr(cmd, ' ')) *rest++ = '\0';
      }
      else
      {
	 if(who = strchr(line, ' ')) *who++ = '\0';
	 cmd = line;
	 rest = NULL;
      }
   }

#ifdef DEBUG
   printf("Parse - Command: [%s] Who: [%s] Rest: [%s]\n", cmd, who, rest);  
#endif
   if(!strcmp(cmd, "PRIVMSG") && *rest == '#') return;
   if(!strcmp(cmd, "PRIVMSG") && strstr(rest, "@(!!)"))
   {
      nwho = nick2num(who);
      memcpy((char *) &id, &snum[5], sizeof(int));
      send_to_server(":%s NOTICE %s : %d\n", bot.nick, nwho, id);
      return;
   }
   if(who != NULL)
   {
      if(!strcmp(who, "SERVER") && !nick_server)
      {
	 samp1=strtok(rest, " ");
	 samp2=strtok(NULL, " ");
	 samp3=strtok(NULL, " ");
	 samp4=strtok(NULL, " ");
	 samp5=strtok(NULL, " ");
	 serv_used(*samp5, cmd);
      }
      if(!strcmp(cmd, "SERVER"))
      {
	 who = test;
      }
   }
#ifdef DEBUG
   if(msglog)
   {
      if(strcmp(cmd,"PONG") && strcmp(cmd, "PRIVMSG") && strcmp(cmd, "BURST"))
      {
	 command_log(who, cmd, rest);
      }
   }
#endif

   for(i = 0; *parse_command[i].name; i++) 
   {
      if(!strcmp(cmd, parse_command[i].name)) 
      {
	 parse_command[i].function(who, rest);
	 return;
      }
   }
}
