/* UW9 - Operator Services uw-src/parse_server.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include <bot.h>

void parse_server(char *who, char *rest)
{
   struct hubinfo *new;
   char *link = NULL, *server = NULL;
   int jupe = 0;

   if(rest == NULL) return;
   if(strstr(rest, ":JUPE -")) jupe = 1;
   link = strtok(rest, " ");
   server=num2serv(*who);
   log(SQTLOG_FILE, "[%s] Server Connect:  HUB: %s  Connecting Leaf: %s\n", date(), server, link);
   free_maplist();
   if(joined)
   {
      if(jupe)
      {
	 send_to_server(":%s WALLOPS :Juped Server %s added\n", myserver, link);
      }
      send_to_server(":%s MAP\n", bot.nick);
   }
   new = (struct hubinfo *) calloc(1, sizeof(struct hubinfo));
   if(new != NULL)
   {
      new->next = NULL;
      strcpy(new->main, server);
      strcpy(new->link, link);
      if(hubhead == NULL)
      {
	 hubhead = new;
	 hubtail = new;
	 hubhead->prev=NULL;
      }
      else
      {
	 new->prev=hubtail;
	 hubtail->next = new;
	 hubtail=new;
      }
   }
   else log(ERRLOG_FILE, "[%s] Adding new Hub/Link: Out of memory\n", date());
}
