/* UW9 - Operator Services uw-src/ret_operinfo.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

struct operinfo *return_maskinfo(char *who)
{
   struct operinfo *current;
   struct adderinfo *current1;
   int bool = 0;
   char uhost[100], cuhost[100], buhost[100], *nuhost = NULL, *duhost = NULL, *host = NULL, *nwho = NULL, *newhost, newhost1[100];

   cuhost[0] = '\0';
   buhost[0] = '\0';
   if(!strchr(who, '@'))
   {
      nwho = nick2num(who);
      if(nwho == NULL) return NULL;
   }
   else
   {
      sprintf(uhost, "*%s", who);
      bool = 1;
   }
   current = operhead;
   while(current != NULL)
   {
      if(!bool)
      {
	 return NULL;
      }
      else
      {
	 current1 = current->adderhead;
	 while(current1 != NULL)
	 {
	    collapse(uhost);
	    if(!bancmp(current1->address, uhost) || !wwcmp(current1->address, uhost))
	    {
	       return current;
	    }
	    current1 = current1->next;
	 }
      }
      current = current->next;
   }
   return NULL;
}

struct operinfo *return_operinfo(char *who)
{
   struct operinfo *current1;
   struct adderinfo *current2;
   char *uhost;

   uhost = getnickuserhost(who);
   if(uhost == NULL) return NULL;
   current1 = operhead;
   while(current1 != NULL) 
   {
      current2 = current1->adderhead;
      while(current2 != NULL)
      {
	 collapse(uhost);
	 if(!bancmp(current2->address, uhost) || !wwcmp(current2->address, uhost))
	 {
	    return current1;
	 }
	 current2 = current2->next;
      }
      current1 = current1->next;
   }
   return NULL;
}


struct adderinfo *ret_oper_addrinfo(char *who, char *chan)
{
   struct operinfo *current1;
   struct adderinfo *current2;

   current1 = operhead;
   while(current1 != NULL) 
   {
      current2 = current1->adderhead;
      while(current2 != NULL)
      {
	 collapse(who);
	 if(!bancmp(current2->address, who) || !bancmp(who, current2->address))
	 {
	    if(current1->suspend == TRUE) return NULL;
	    return current2;
	 }
	 current2 = current2->next;
      }
      current1 = current1->next;
   }
   return NULL;
}

struct operinfo *ret_oper_level(char *who)
{
   struct operinfo *current1;
   current1 = operhead;
   while(current1 != NULL) 
   {
      if(!strcasecmp(who, current1->nick)) 
      {
	 return current1;
      }
      current1 = current1->next;
   }
   return NULL;
}

struct nickinfo *return_chaninfo(char *nick, char *channel)
{
   struct nickinfo *current;
   struct chaninfo *chan;
   current = nickhead;
   while(current != NULL)
   {
      if(!strcasecmp(nick,current->nick))
      {
	 chan = current->chanhead;
	 while(chan != NULL)
	 {
	    if(!strcasecmp(channel, chan->channel))
	    {
	       return current;
	    }
	    chan = chan->next;
	 }
      }
      current = current->next;
   }
   return NULL;
}

struct nickinfo *return_nickinfo(char *nick)
{
   struct nickinfo *current;
   current = nickhead;
   while(current != NULL)
   {
      if(!strcasecmp(nick,current->nick))
      {
	 return current;
      }
      current = current->next;
   }
   return NULL;
}

struct operinfo *ret_oper_operinfo(char *who)
{
   struct operinfo *current1;
   current1 = operhead;
   while(current1 != NULL)
   {
      if(!strcasecmp(who, current1->nick))
      {
	 return current1;
      }
      current1 = current1->next;
   }
   return NULL;
}
