/* UW9 - Operator Services uw-src/swap_host.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

char *swap_host(char *who, char *usrhost)
{
   struct nickinfo *nick;
   char *hostip, *host;

   nick = nickhead;
   while(nick != NULL)
   {
      if(!strcasecmp(who, nick->nick))
      {
         hostip = dectoip(base64toint(nick->base64));
      }
      nick = nick->next;
   }
   if(host = strchr(usrhost, '@')) *host++ = '\0';
   sprintf(userhost, "%s@%s", usrhost, hostip);
   return(userhost);
}

int base64toint(const char *s)
{
  unsigned int i = convert2n[(unsigned char)*s++];
  while (*s)
  {
    i <<= NUMNICKLOG;
    i += convert2n[(unsigned char)*s++];
  }
  return i;
}

int isipaddr(char *mask)
{
  int isipaddr = 0;
  char *p;

  for (p = mask; *p; ++p)
    if (*p == '.')
    {
      isipaddr = -1;
    }

  return isipaddr;
}

char *dectoip(int myip)
{
  static char buf[16];
  unsigned char *s = (unsigned char *)&myip;
  unsigned char a, b, c, d;

  a = *s++;
  b = *s++;
  c = *s++;
  d = *s++;
#ifdef SUN
  sprintf(buf, "%u.%u.%u.%u", a, b, c, d);
#else
  sprintf(buf, "%u.%u.%u.%u", d, c, b, a);
#endif
  return buf;
}

