/* UW9 - Operator Services uw-src/unban.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include <bot.h>

void unban(char *who, char *rest)
{
   char *chan, *banmask, *nwho, *helpname;

   helpname = get_command_name("unban");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   chan = strtok(rest, " ");
   if(*chan == '+' || *chan == '&') return;
   if(chan_check(chan, who) == -1) return;
   banmask = strtok(NULL, " ");
   if(banmask == NULL)
   {
      do_help(who, helpname);
      return;
   }
   send_to_server(":%s MODE %s -b %s\n", myserver, chan, banmask);  

}
