/* UW9 - Operator Services uw-src/ban.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include <bot.h>

void ban(char *who, char *rest)
{
   char *ban_person, *chan, *nwho;
   struct userinfo *tmp;
   nwho=nick2num(who);
   if(rest == NULL)
   {
      send_to_server(":%s NOTICE %s :I believe you need to review the help\n", bot.nick, nwho);
      return;
   }
   if(rest[0] == '\0')
   {
      send_to_server(":%s NOTICE %s :I believe you need to review the help\n", bot.nick, nwho);
      return;
   }
   chan = strtok(rest, " ");
   if(*chan == '+' || *chan == '&') return;
   strlwr(chan);
   if(chan_check(chan, who) == -1) return;
   ban_person = strtok(NULL, " ");
   if(ban_person == NULL) return;
   if(strchr(ban_person, '@') && strchr(ban_person, '!'))
   {
      send_to_server(":%s MODE %s +b %s\n", myserver, chan, ban_person);
   }
   else
   {
      char *ban_addr, *ptr, *ptr2;
      if(!strcasecmp(bot.nick, ban_person)) return;
      if((ban_addr = getuserhost(ban_person)) == NULL) return;
      if(ptr = strchr(ban_addr, '@')) *ptr++ = '\0';
      if(ptr2 = strchr(ptr, '.'));
      send_to_server(":%s MODE %s +b *!*%s@*%s\n", myserver, chan, ban_addr, ptr2);
   }
}

long convert_duration(char *unit, long duration)
{
   long newtime;
   if(!strcasecmp(unit, "seconds") || !strcasecmp(unit, "second"))
   {
      return duration;
   }
   if(!strcasecmp(unit, "minutes") || !strcasecmp(unit, "minute"))
   {
      newtime = duration * 60;
      return newtime;
   }
   if(!strcasecmp(unit, "hours") || !strcasecmp(unit, "hour"))
   {
      newtime = duration * 60 * 60;
      return newtime;
   }
   if(!strcasecmp(unit, "days") || !strcasecmp(unit, "day"))
   {
      newtime = duration * 60 * 60 * 24;
      return newtime;
   }
   if(!strcasecmp(unit, "weeks") || !strcasecmp(unit, "week"))
   {
      newtime = duration * 60 * 60 * 24 * 7;
      return newtime;
   }
   if(!strcasecmp(unit, "months") || !strcasecmp(unit, "month"))
   {
      newtime = duration * 60 * 60 * 24 * 30;
      return newtime;
   }
   return 0;
}
