/* UW9 - Operator Services uw-src/chk_access.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

int check_access(char *who, char *rest, int level, char *cmd)
{
   struct nickinfo *nick;
   struct operinfo *oper;
   char *nwho, *helpname, *helpname1;

   added_level = 0;
   nwho = nick2num(who);
   oper = return_operinfo(who);
   nick = return_nickinfo(who);
   helpname = get_command_name("copyright");
   helpname1 = get_command_name("credits");
   if(!strcasecmp(cmd, helpname) || !strcasecmp(cmd, helpname1) || strstr(cmd, "FINGER") || strstr(cmd, "VERSION") || strstr(cmd, "PING") || strstr(cmd, "USERINFO") || strstr(cmd, "CLIENTINFO") || strstr(cmd, "TIME") || strstr(cmd, "DCC")) return 1;
   if(oper != NULL && nick->is_oper)
   {
      if(oper->suspend)
      {
	 send_to_server(":%s NOTICE %s :Your %s Access has been suspended\n", bot.nick, nwho, bot.nick);
	 return 0;
      }            
      if(level == 0 && nick->is_oper)
      {
	 oper->lastseen = time(NULL);
	 return 1;
      }
      added_level = oper->level;
      if(oper->level < level)
      {
	 send_denied_msg(who);
	 return 0;
      }
      oper->lastseen = time(NULL);
      return 1;
   }
   if(level == 0 && nick->is_oper) return 1;
   if(rest == NULL) 
   {
      send_denied_msg(who);
      return 0;
   }
   send_denied_msg(who);
   added_level = 0;
   return 0;
}
