/* UW9 - Operator Services uw-src/ctcp.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

void clone_ctcp_dcc(char *who, char *rest)
{
   struct nickinfo *nick;
   char *nwho = NULL, *mwho = NULL;

   mwho = num2nick(rest);
   nwho = nick2num(who);
   nick = return_nickinfo(mwho);
   if(nick == NULL || !strcasecmp(mwho, bot.nick)) return;
}

void clone_ctcp_time(char *who, char *rest)
{
   struct nickinfo *nick;
   char *nwho = NULL, *mwho = NULL;

   mwho = num2nick(rest);
   nwho = nick2num(who);
   nick = return_nickinfo(mwho);
   if(nick == NULL || !strcasecmp(mwho, bot.nick)) return;
   send_to_server(":%s NOTICE %s :%cTIME %s\n", nick->nick, nwho, CTCP_DELIM_CHAR, get_time(time(NULL)));
}


void clone_ctcp_clientinfo(char *who, char *rest)
{
   struct nickinfo *nick;
   char *nwho = NULL, *mwho = NULL;

   mwho = num2nick(rest);
   nwho = nick2num(who);
   nick = return_nickinfo(mwho);
   if(nick == NULL || !strcasecmp(mwho, bot.nick)) return;
}

void clone_ctcp_userinfo(char *who, char *rest)
{
   struct nickinfo *nick;
   char *nwho = NULL, *mwho = NULL;

   mwho = num2nick(rest);
   nwho = nick2num(who);
   nick = return_nickinfo(mwho);
   if(nick == NULL || !strcasecmp(mwho, bot.nick)) return;
   send_to_server(":%s NOTICE %s :%cUSERINFO %s\n", nick->nick, nwho, CTCP_DELIM_CHAR, nick->name);
}

void clone_ctcp_finger(char *who, char *rest)
{
   struct nickinfo *nick;
   char *nwho = NULL, *mwho = NULL;

   mwho = num2nick(rest);
   nwho = nick2num(who);
   nick = return_nickinfo(mwho);
   if(nick == NULL || !strcasecmp(mwho, bot.nick)) return;
   send_to_server(":%s NOTICE %s :%cFINGER Fingers are not allowed to this host.\n", nick->nick, nwho, CTCP_DELIM_CHAR, rest);
}

void clone_ctcp_ping(char *who, char *clone, char *rest)
{
   struct nickinfo *nick;
   char *nwho = NULL, *mwho = NULL;

   mwho = num2nick(clone);
   if(mwho == NULL) return;
   nwho = nick2num(who);
   nick = return_nickinfo(mwho);
   if(nick == NULL) return;
   send_to_server(":%s NOTICE %s :%cPING %s\n", nick->nick, nwho, CTCP_DELIM_CHAR, rest);
}

void ctcp_ping(char *who, char *rest)
{
   char *nwho = NULL;

   nwho = nick2num(who);
   send_to_server(":%s NOTICE %s :%cPING %s\n", bot.nick, nwho, CTCP_DELIM_CHAR, rest);
}

void ctcp_version(char *who, char *rest)
{
   struct nickinfo *nick;
   char *nwho = NULL, *mwho = NULL;

   if(rest == NULL) return;
   mwho = num2nick(rest);
   nwho = nick2num(who);
   nick = return_nickinfo(mwho);
   if(nick == NULL || !strcasecmp(mwho, bot.nick))
      send_to_server(":%s NOTICE %s :%cVERSION %s %s%c\n", bot.nick, nwho, CTCP_DELIM_CHAR, myhost, "UW9.2 Copyright  1998-2000(IRCore)", CTCP_DELIM_CHAR);
   else
      send_to_server(":%s NOTICE %s :%cVERSION %s %s%c\n", nick->nick, nwho, CTCP_DELIM_CHAR, nick->host, "mIRC32 v5.6 K.Mardam-Bey", CTCP_DELIM_CHAR);
}

void copyright(char *who, char *rest)
{
   char *nwho;

   nwho = nick2num(who);
   send_to_server(":%s NOTICE %s :  UW9.2 Copyright  1998-2000(IRCore)\n", bot.nick, nwho);
}

void credits(char *who, char *rest)
{
   char *nwho = NULL;

   nwho = nick2num(who);

   send_to_server(":%s NOTICE %s : - \n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s : Dogbert!dogbert@othernet.org (John Wiles)\n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s :   John is mans best friend, he helped test and\n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s :   provide feedback and many other things, that\n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s :   without him I may have given up long ago\n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s :   Thanks John\n", bot.nick, nwho);

   send_to_server(":%s NOTICE %s : - \n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s : het!het@othernet.org (Kiel MacEwan)\n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s :   What a pain this guy is, but again a major asset\n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s :   to the team, he has provided valuable insight to\n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s :   what the users need and want, he has also done\n", bot.nick, nwho); 
   send_to_server(":%s NOTICE %s :   major work on the documentation and testing.\n", bot.nick, nwho); 
   send_to_server(":%s NOTICE %s :   Kiel, thanks for taking on the tasks.\n", bot.nick, nwho);

   send_to_server(":%s NOTICE %s : - \n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s :   KrAzE!KrAzE@PowerChat.Net (James Brady)\n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s :   I think this guy beat het out for being a pain, but\n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s :   he has also been the single most help this year(1999)\n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s :   in aiding me for finding bugs and developing CS6 to\n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s :   what it is today, thanks James.\n", bot.nick, nwho);

   send_to_server(":%s NOTICE %s : - \n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s : All the loyal users in the Othernet family that\n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s : put up with the daily nonsence of my working on\n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s : CS5 - CS6 and using them as lab rats.  I apologize\n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s : for not being able to list you all here, for\n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s : fear of leaving some one out.\n", bot.nick, nwho);

   send_to_server(":%s NOTICE %s : - \n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s :                                 Chris Birch\n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s :                                    Opus\n", bot.nick, nwho);
   send_to_server(":%s NOTICE %s :                                  1998-1999\n", bot.nick, nwho);
}
