/* UW9 - Operator Services src/add_badchan.c
 * UW8.0, UW8.1 and UW9.0 Copyright  1998-1999 Chris Birch(IRCore)
 */
#ifdef DEF_GLOBALS
char line[MAXLEN];     /* line parsed by the bot */
char linebuff[100];
char linebuff1[100];
char ip[100];
char dnsname[100];
char whoislist[6000];
char modelist[1000];
char banlist[6000];
char userhost[100];    /* global user@host of user */
char banmask[100]; 
char denied_msg[100];  /* msg to send when he is denied access */
char strbuff[70];  /* used in strupr and strlwr */
int socketfd;          /* socket descriptor */
int flood_count;       /* number of people who are flooding */
int flood_rate;        /* how many lines of message... */
int flood_time;        /* ...within what span of time? */
int reset_time;        /* time to wait for until it resets flood */
int alarmed;           /* did we call an alarm() call */
int msglog;
int added_level;
int servsync;
int ymsgchan;
int no_servers;
int msgchan;
int found_it;
int did_eoback;
int end_map;
int killflood;
long blocktime;
int y_privmsg;
int gotone;
int joined;
int number;
int colorm;
int adm_gline;
int maxnumber;
char maxdate[100];
int minnumber;
int trk_servers;
long uptime;           /* how long has the bot been up? */
long savetime;         /* when was the last time we saved the userlist? */
char snum[12]="@(!!)\0\0\0\0\0\0";
long pingtime;         /* when was the last time we pinged the server? */
long lasttime;         /* when was the last time we pinged the server? */
long botstart;
long msgchan_time;
char default_level[100];
char pid_file[100];
char botnick[100];
char ircuser[100];
char reason[100];
char mymodes[100];
char myserver[100];
char netpass[100];
char myuhost[100];
char myhost[100];
char ircname[100];
char msg_chan[100];
char quit_msg[100];
char gender_rpl[100]; 
char version_rpl[100]; 
char chanhost[100]; 
char teamchan[200]; 
char chanserv[100]; 
char newtime[100];
char comchar; 
char regsuffix[100];
int maxoperlevel; 
int maxnicklen; 
int deopchan; 
int logging; 
int maxclones;
int clonemsg;
int server_num;

struct ginfo *ghead = NULL;
struct cinfo *chead = NULL;
struct badinfo *badhead = NULL;
struct killinfo *killhead = NULL;
struct secretinfo *secrethead = NULL;
struct trustinfo *trusthead = NULL;
struct SERVERS servers[20];
struct servinfo servinfo[NUMNICKBASE];
struct usernums usernums[MAXNUM];
struct mapinfo *maphead = NULL;
struct hubinfo *hubhead = NULL;
struct roominfo *roomhead = NULL;
struct modeinfo *modehead = NULL;
struct hubinfo *hubtail = NULL;
struct templist *listhead = NULL;
struct protinfo *prothead = NULL;
struct resvinfo *resvhead = NULL;
struct jupeinfo *jupehead = NULL;
struct nickinfo *nickhead = NULL;
struct chaninfo *chanhead = NULL;
struct hostchk *hosthead = NULL;
struct operinfo *operhead = NULL;
struct flooding flood[100];
struct sortit sortcom[100];
struct bots bot;
struct PARSE_COMMAND parse_command[] = 
{
   { "SERVER",   parse_server  },
   { "ACTION",   parse_action  },
   { "PING",     parse_ping    },
   { "PONG",     parse_pong    },
   { "KICK",     parse_kick    },
   { "PRIVMSG",  parse_privmsg },
   { "MODE",     parse_mode    },
   { "KILL",     parse_kill    },
   { "JOIN",     parse_join    },
   { "NICK",     parse_nick    },
   { "QUIT",     parse_quit    },
   { "SQUIT",    parse_squit   },
   { "PASS",     parse_pass    },
   { "PART",     parse_part    },
   { "367",      parse_367     },
   { "353",      parse_353     },
   { "324",      parse_324     },
   { "332",      parse_332     },
   { "005",	 parse_005     },
   { "AWAY",     parse_away    },
   { "BURST",    parse_burst   },
   { "CREATE",   parse_create  },
   { "END_OF_BURST",   parse_eoburst  },
   { "EOB_ACK",   parse_eob_ack},
   { "",         NULL          }
};

/*
command, filler, function, level, arg, disable
*/
struct COMMANDS commands[] = 
{
   { "die",          " ",  die,                      900,   0, 0  },
   { "addoper",      " ",  add_oper,                 800,   1, 0  },
   { "addprot",      " ",  add_prot,                 950,   1, 0  },
   { "delprot",      " ",  del_prot,                 950,   1, 0  },
   { "deloper",      " ",  delete_oper,              800,   1, 0  },
   { "modoper",      " ",  mod_oper,                 800,   1, 0  },
   { "write",        " ",  write_all_files,          800,   0, 0  },
   { "restart",      " ",  rehash,                   900,   0, 0  },
   { "chcomname",    " ",  change_comm_name,         900,   1, 0  },
   { "chlevel",      " ",  change_comm_level,        900,   1, 0  },
   { "disablecom",   " ",  disablecomm,              900,   1, 0  },
   { "enablecom",    " ",  enablecomm,               900,   1, 0  },
   { "showdiscom",   " ",  showdisabled,             800,   0, 0  },
   { "join",         " ",  join,                     800,   1, 0  },
   { "leave",        " ",  part,                     800,   1, 0  },
   { "jupe",         " ",  jupe,                     800,   1, 0  },
   { "unjupe",       " ",  unjupe,                   800,   1, 0  },
   { "reserve",      " ",  reserve,                  800,   1, 0  },
   { "unreserve",    " ",  unreserve,                800,   1, 0  },
   { "addbad",       " ",  add_bad,                  800,   1, 0  },
   { "delbad",       " ",  del_bad,                  800,   1, 0  },
   { "addkill",      " ",  add_kill,                 800,   1, 0  },
   { "delkill",      " ",  del_kill,                 800,   1, 0  },
   { "addsecret",    " ",  add_secret,               800,   1, 0  },
   { "delsecret",    " ",  del_secret,               800,   1, 0  },
   { "addtrust",     " ",  add_trust,                800,   1, 0  },
   { "deltrust",     " ",  del_trust,                800,   1, 0  },
   { "collide",      " ",  collide,                  800,   1, 0  },
   { "settime",      " ",  settime,                  800,   0, 0  },
   { "clone",        " ",  clone,                    999,   1, 0  },
   { "quit",         " ",  clone_quit,               999,   1, 0  },
   { "say",          " ",  clone_say,                999,   1, 0  },
   { "clonepart",    " ",  clone_part,               999,   1, 0  },
   { "clonejoin",    " ",  clone_join,               999,   1, 0  },
   { "inviteme",     " ",  inviteme,                 500,   0, 0  },
   { "broadcast",    " ",  broadcast,                500,   1, 0  },
   { "clearchan",    " ",  clearchan,                500,   1, 0  },
   { "chankill",     " ",  chankill,                 500,   1, 0  },
   { "hostkill",     " ",  hostkill,                 500,   1, 0  },
   { "uptime",       " ",  show_uptime,              000,   0, 0  },
   { "opall",        " ",  opall,                    400,   1, 0  },
   { "suspendoper",  " ",  suspend,                  900,   1, 0  },
   { "kickbanall",   " ",  kick_ban_all,             450,   1, 0  },
   { "kickall",      " ",  kick_all,                 400,   1, 0  },
   { "clearbans",    " ",  clearban,                 300,   1, 0  },
   { "clearmodes",   " ",  clearmode,                400,   1, 0  },
   { "mode",         " ",  mode,                     100,   1, 0  },
   { "deopall",      " ",  deopall,                  400,   1, 0  },
   { "ungline",      " ",  do_ungline,               400,   1, 0  },
   { "gline",        " ",  do_gline,                 400,   1, 0  },
   { "moderate",     " ",  moderate,                 300,   1, 0  },
   { "unmoderate",   " ",  unmoderate,               300,   1, 0  },
   { "ban",          " ",  ban,                      100,   1, 0  },
   { "unban",        " ",  unban,                    100,   1, 0  },
   { "nickban",      " ",  nickban,                  100,   1, 0  },
   { "kickban",      " ",  kick_ban,                 100,   1, 0  },
   { "refreshg",     " ",  refresh_glines,           100,   0, 0  },
   { "deop",         " ",  deop,                     100,   1, 0  },
   { "kick",         " ",  kick_user,                100,   1, 0  },
   { "op",           " ",  giveop,                   100,   1, 0  },
   { "list",         " ",  list_it,                  0,     1, 0  },
   { "mkpasswd",     " ",  get_crypt,                0,     1, 0  },
   { "access",       " ",  show_access,              0,     1, 0  },
   { "getdns",       " ",  get_dns,                  0,     1, 0  },
   { "getip",        " ",  get_ip,                   0,     1, 0  },
   { "block",        " ",  block,                    0,     1, 0  },
   { "help",         " ",  help,                     0,     0, 0  },
   { "whois",        " ",  whois,                    0,     1, 0  },
   { "map",          " ",  show_map,                 0,     0, 0  },
   { "operlist",     " ",  operlist,                 0,     0, 0  },
   { "hostchk",      " ",  hostchk,                  0,     1, 0  },
   { "opermsg",      " ",  opermsg,                  0,     1, 0  },
   { "whoison",      " ",  whoison,                  0,     1, 0  },
   { "ison",         " ",  ison,                     0,     1, 0  },
   { "credits",      " ",  credits,                  0,     0, 0  },
   { "copyright",    " ",  copyright,                0,     0, 0  },
   { "showcommands", " ",  showcommands,             0,     0, 0  },
  { "\001ping",     " ",  ctcp_ping,                0,     0, 0  },
   { "\001version\001", " ",  ctcp_version,          0,     0, 0  },
   { "\001finger\001", " ",  clone_ctcp_finger,          0,     0, 0  },
   { "\001userinfo\001", " ",  clone_ctcp_userinfo,          0,     0, 0  },
   { "\001clientinfo\001", " ",  clone_ctcp_clientinfo,          0,     0, 0  },
   { "\001time\001", " ",  clone_ctcp_time,          0,     0, 0  },
   { "",             " ",  NULL,                     0,     0, 0  },
};
char convert2y[NUMNICKBASE] = {
  'A','B','C','D','E','F','G','H','I','J','K','L','M',
  'N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
  'a','b','c','d','e','f','g','h','i','j','k','l','m',
  'n','o','p','q','r','s','t','u','v','w','x','y','z',
  '0','1','2','3','4','5','6','7','8','9',
  '[',']'
};

int convert2n[] = {
   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  52,53,54,55,56,57,58,59,60,61, 0, 0, 0, 0, 0, 0,
   0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,
  15,16,17,18,19,20,21,22,23,24,25,62, 0,63, 0, 0,
   0,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,48,49,50,51, 0, 0, 0, 0, 0,

   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};

#else
extern char line[];
extern char linebuff[];
extern char linebuff1[];
extern char ip[];
extern char dnsname[];
extern char whoislist[];
extern char modelist[];
extern char userhost[];
extern char banmask[];
extern char denied_msg[];
extern char strbuff[];  
extern int socketfd;
extern int flood_count;
extern int flood_rate;
extern int flood_time;
extern int reset_time;
extern int alarmed; 
extern int added_level;
extern int servsync;
extern int ymsgchan;
extern int no_servers;
extern int found_it;
extern int end_map;
extern int gotone;
extern int joined;
extern int number;
extern int colorm;
extern int adm_gline;
extern int maxnumber;
extern char maxdate[100];
extern int minnumber;
extern int trk_servers;
extern int msglog;
extern int server_num;
extern long uptime;
extern long savetime;
extern long pingtime; 
extern long botstart;
extern long lasttime;
extern long msgchan_time;
extern char default_level[];
extern char pid_file[];
extern char botnick[];
extern char ircuser[];
extern char reason[];
extern char mymodes[];
extern char myserver[];
extern char netpass[];
extern char myuhost[];
extern char myhost[];
extern char ircname[];
extern char msg_chan[];
extern char quit_msg[];
extern char chanhost[]; 
extern char teamchan[]; 
extern char comchar; 
extern char regsuffix[];
extern char snum[];
extern int killflood;
extern long blocktime;
extern int y_privmsg;
extern int did_eoback;
extern int maxoperlevel; 
extern int maxnicklen; 
extern int deopchan; 
extern int logging; 
extern int maxclones;
extern int clonemsg;
extern char chanserv[]; 
extern char newtime[];
extern char convert2y[];
extern int convert2n[];

extern struct cinfo *chead;
extern struct ginfo *ghead;
extern struct badinfo *badhead;
extern struct killinfo *killhead;
extern struct secretinfo *secrethead;
extern struct trustinfo *trusthead;
extern struct SERVERS servers[];
extern struct servinfo servinfo[];
extern struct usernums usernums[];
extern struct mapinfo *maphead;
extern struct roominfo *roomhead;
extern struct modeinfo *modehead;
extern struct hubinfo *hubhead;
extern struct hubinfo *hubtail;
extern struct nickinfo *nickhead;
extern struct chaninfo *chanhead;
extern struct hostchk *hosthead;
extern struct protinfo *prothead;
extern struct templist *listhead;
extern struct resvinfo *resvhead;
extern struct jupeinfo *jupehead;
extern struct operinfo *operhead;
extern struct flooding flood[];
extern struct sortit sortcom[];
extern struct bots bot;
extern struct PARSE_COMMAND parse_command[];
extern struct COMMANDS commands[];
#endif
