/* UW9 - Operator Services uw-src/rehash.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

void rehash()
{
   int i;
   char *botnum;

   botnum=get_usernum(bot.nick);
   delete_usernum(botnum);
   free_ginfo();
   free_jupeinfo();
   free_resvinfo();
   free_badchan();
   free_killchan();
   free_secret();
   free_trusted();
   free_hublist();
   free_protlist();
   free_roomlist();
   free_nicklist();
   send_to_server(":%s WALLOPS :Re-initializing Operator Services\n", myserver);
   if(ymsgchan)
      send_to_server(":%s PRIVMSG %s :Re-initializing Operator Services.\n", bot.nick, msg_chan);
   send_to_server(":%s QUIT :%s\n", bot.nick, quit_msg);
   send_to_server(":%s SQUIT %s :Just keeps getting better and better !\n", myserver, myserver);
   close(socketfd);
   load_cfg();
   if((i = get_connection(bot.server, bot.port)) != -1)
   {
      log(LOG_FILE, "[%s] Rehashing %s\n", date(), bot.nick);
      socketfd = i;
      init_bot();
   }
}
