/* UW9 - Operator Services uw-src/show_access.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

void show_access(char *who, char *rest)
{
   struct operinfo *oper;
   struct adderinfo *addr, *tmp;
   char *aut = "OFF", *prot = "OFF", *suspend = "OFF", *helpname;
   char *nwho, *nick, sbuff1[1000], sbuff[1000], buff[1000], test[100];
   int howmany = 0;

   helpname = get_command_name("access");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   buff[0] = '\0';
   sbuff[0] = '\0';
   nick = strtok(rest, " ");
   if(nick == NULL)
   {
      do_help(who, helpname);
      return;
   }
   nwho = nick2num(who);

   if((nick[0] == '>' || nick[0] == '<' || nick[0] == '=') && nick[1] == ' ')
   {   
      send_to_server(":%s NOTICE %s : There should be no space after the < or > or = sign \n", bot.nick, nwho);
      return;
   }      
   if((nick[0] == '>' || nick[0] == '<' || nick[0] == '=') && !isdigit(nick[1]))
   {   
      send_to_server(":%s NOTICE %s : The level value must be a number < or > sign \n", bot.nick, nwho);
      return;
   }      
   if(nick[0] == '>')
   {
      *nick++;
      oper = operhead;
      while(oper != NULL)
      {
	 if(atoi(nick) < oper->level)
	 {
            if(colorm)
            {
	       if(oper->suspend == 0) suspend = "\0034OFF\003";
	       else suspend = "\0033ON\003";
	       send_to_server(":%s NOTICE %s : \0031Profile: [\003\00312 %s\003\0031 ] [\003\0034 %d\003\0031 ] \0031Suspend:\003 %s\n", bot.nick, nwho, oper->nick, oper->level, suspend);
	       send_to_server(":%s NOTICE %s : \0031LastSeen: \003\0034 %s\003\n", bot.nick, nwho, get_time(oper->lastseen));
            }
            else
            {
	       if(oper->suspend == 0) suspend = "OFF";
	       else suspend = "ON";
	       send_to_server(":%s NOTICE %s : Profile: [ %s ] [ %d ] Suspend: %s\n", bot.nick, nwho, oper->nick, oper->level, suspend);
	       send_to_server(":%s NOTICE %s : LastSeen: %s\n", bot.nick, nwho, get_time(oper->lastseen));
            }
	    sbuff[0] = '\0';
	    buff[0] = '\0';
	    howmany++;
	    addr = oper->adderhead;
	    while(addr != NULL)
	    {
	       sprintf(sbuff, "%s  ", addr->address);
	       strcat(buff, sbuff);
	       addr = addr->next;
	    }
            if(colorm)
	       send_to_server(":%s NOTICE %s : \0031Masks:\003\0032 %s\003\n", bot.nick, nwho, buff);
            else
	       send_to_server(":%s NOTICE %s : Masks: %s\n", bot.nick, nwho, buff);
	    send_to_server(":%s NOTICE %s : -\n", bot.nick, nwho);
	 }	     
	 oper = oper->next;
      }
      return;
   }
   if(nick[0] == '<')
   {
      *nick++;
      oper = operhead;
      while(oper != NULL)
      {
	 if(atoi(nick) > oper->level)
	 {
            if(colorm)
            {
	       if(oper->suspend == 0) suspend = "\0034OFF\003";
	       else suspend = "\0033ON\003";
	       send_to_server(":%s NOTICE %s : \0031Profile: [\003\00312 %s\003\0031 ] [\003\0034 %d\003\0031 ] \0031Suspend:\003 %s\n", bot.nick, nwho, oper->nick, oper->level, suspend);
	       send_to_server(":%s NOTICE %s : \0031LastSeen: \003\0034 %s\003\n", bot.nick, nwho, get_time(oper->lastseen));
            }
            else
            {
	       if(oper->suspend == 0) suspend = "OFF";
	       else suspend = "ON";
	       send_to_server(":%s NOTICE %s : Profile: [ %s ] [ %d ] Suspend: %s\n", bot.nick, nwho, oper->nick, oper->level, suspend);
	       send_to_server(":%s NOTICE %s : LastSeen:  %s\n", bot.nick, nwho, get_time(oper->lastseen));
            }
	    sbuff[0] = '\0';
	    buff[0] = '\0';
	    howmany++;
	    addr = oper->adderhead;
	    while(addr != NULL)
	    {
	       sprintf(sbuff, "%s  ", addr->address);
	       strcat(buff, sbuff);
	       addr = addr->next;
	    }
            if(colorm)
	       send_to_server(":%s NOTICE %s : \0031Masks:\003\0032 %s\003\n", bot.nick, nwho, buff);
            else
	       send_to_server(":%s NOTICE %s : Masks: %s\n", bot.nick, nwho, buff);
	    send_to_server(":%s NOTICE %s : -\n", bot.nick, nwho);
	 }	     
	 oper = oper->next;
      }
      return;
   }
   if(nick[0] == '=')
   {
      *nick++;
      oper = operhead;
      while(oper != NULL)
      {
	 sbuff[0] == '\0';
	 buff[0] == '\0';
	 if(atoi(nick) == oper->level)
	 {
            if(colorm)
            {
	       if(oper->suspend == 0) suspend = "\0034OFF\003";
               else suspend = "\0033ON\003";
   	       send_to_server(":%s NOTICE %s : \0031Profile: [\003\00312 %s\003\0031 ] [\003\0034 %d\003\0031 ] \0031Suspend:\003 %s\n", bot.nick, nwho, oper->nick, oper->level, suspend);
	       send_to_server(":%s NOTICE %s : \0031LastSeen: \003\0034 %s\003\n", bot.nick, nwho, get_time(oper->lastseen));
            }
            else
            {
	       if(oper->suspend == 0) suspend = "OFF";
               else suspend = "ON";
   	       send_to_server(":%s NOTICE %s : Profile: [ %s ] [ %d ] Suspend: %s\n", bot.nick, nwho, oper->nick, oper->level, suspend);
	       send_to_server(":%s NOTICE %s : LastSeen:  %s\n", bot.nick, nwho, get_time(oper->lastseen));
            }
	    sbuff[0] = '\0';
	    buff[0] = '\0';
	    howmany++;
	    addr = oper->adderhead;
	    while(addr != NULL)
	    {
	       sprintf(sbuff, "%s  ", addr->address);
	       strcat(buff, sbuff);
	       addr = addr->next;
	    }
            if(colorm)
	       send_to_server(":%s NOTICE %s : \0031Masks:\003\0032 %s\003\n", bot.nick, nwho, buff);
            else
	       send_to_server(":%s NOTICE %s : Masks: %s\n", bot.nick, nwho, buff);
	    send_to_server(":%s NOTICE %s : -\n", bot.nick, nwho);
	 }	     
	 oper = oper->next;
      }
      return;
   }
   sprintf(sbuff1, "*%s*", nick);
   oper = operhead;
   while(oper != NULL)
   {
      if(!strchr(nick, '@') && !strchr(nick, '*'))
      {
	 if(!bancmp(sbuff1, oper->nick))
	 {
            if(colorm)
            {
	       if(oper->suspend == 0) suspend = "\0034OFF\003";
	       else suspend = "\0033ON\003";
	       send_to_server(":%s NOTICE %s : \0031Profile: [\003\00312 %s\003\0031 ] [\003\0034 %d\003\0031 ] \0031Suspend:\003 %s\n", bot.nick, nwho, oper->nick, oper->level,  suspend);
	       send_to_server(":%s NOTICE %s : \0031LastSeen: \003\0034 %s\003\n", bot.nick, nwho, get_time(oper->lastseen));
            }
            else
            {
	       if(oper->suspend == 0) suspend = "OFF";
	       else suspend = "ON";
	       send_to_server(":%s NOTICE %s : Profile: [ %s ] [ %d ] Suspend: %s\n", bot.nick, nwho, oper->nick, oper->level,  suspend);
	       send_to_server(":%s NOTICE %s : LastSeen:  %s\n", bot.nick, nwho, get_time(oper->lastseen));
            }
	    sbuff[0] = '\0';
	    buff[0] = '\0';
	    howmany++;
	    addr = oper->adderhead;
	    while(addr != NULL)
	    {
	       sprintf(sbuff, "%s  ", addr->address);
	       strcat(buff, sbuff);
	       addr = addr->next;
	    }
            if(colorm)
	       send_to_server(":%s NOTICE %s : \0031Masks:\003\0032 %s\003\n", bot.nick, nwho, buff);
            else
	       send_to_server(":%s NOTICE %s : Masks: %s\n", bot.nick, nwho, buff);
	    send_to_server(":%s NOTICE %s : -\n", bot.nick, nwho);
	 }
      }
      else if(!strchr(nick, '@') && strchr(nick, '*'))
      {
	 if(!bancmp(nick, oper->nick))
	 {
            if(colorm)
            {
	       if(oper->suspend == 0) suspend = "\0034OFF\003";
   	       else suspend = "\0033ON\003";
	       send_to_server(":%s NOTICE %s : \0031Profile: [\003\00312 %s\003\0031 ] [\003\0034 %d\003\0031 ] \0031Suspend:\003 %s\n", bot.nick, nwho, oper->nick, oper->level, suspend);
	       send_to_server(":%s NOTICE %s : \0031LastSeen: \003\0034 %s\003\n", bot.nick, nwho, get_time(oper->lastseen));
            }
            else
            {
	       if(oper->suspend == 0) suspend = "OFF";
   	       else suspend = "ON";
	       send_to_server(":%s NOTICE %s : Profile: [ %s ] [ %d ] Suspend: %s\n", bot.nick, nwho, oper->nick, oper->level, suspend);
	       send_to_server(":%s NOTICE %s : LastSeen:  %s\n", bot.nick, nwho, get_time(oper->lastseen));
            }
	    sbuff[0] = '\0';
	    buff[0] = '\0';
	    howmany++;
	    addr = oper->adderhead;
	    while(addr != NULL)
	    {
	       sprintf(sbuff, "%s  ", addr->address);
	       strcat(buff, sbuff);
	       addr = addr->next;
	    }
            if(colorm)
	       send_to_server(":%s NOTICE %s : \0031Masks:\003\0032 %s\003\n", bot.nick, nwho, buff);
            else
	       send_to_server(":%s NOTICE %s : Masks: %s\n", bot.nick, nwho, buff);
	    send_to_server(":%s NOTICE %s : -\n", bot.nick, nwho);
	 }
      }
      else
      {
	 collapse(nick);
	 addr = oper->adderhead;
	 while(addr != NULL)
	 {
	    if(!bancmp(nick, addr->address) || !bancmp(addr->address, nick))
	    {
               if(colorm)
               {
	          if(oper->suspend == 0) suspend = "\0034OFF\003";
	          else suspend = "\0033ON\003";
	          send_to_server(":%s NOTICE %s : \0031Profile: [\003\00312 %s\003\0031 ] [\003\0034 %d\003\0031 ] \0031Suspend:\003 %s\n", bot.nick, nwho, oper->nick, oper->level, suspend);
	          send_to_server(":%s NOTICE %s : \0031LastSeen: \003\0034 %s\003\n", bot.nick, nwho, get_time(oper->lastseen));
               }
               else
               {
	          if(oper->suspend == 0) suspend = "OFF";
	          else suspend = "ON";
	          send_to_server(":%s NOTICE %s : Profile: [ %s ] [ %d ] Suspend: %s\n", bot.nick, nwho, oper->nick, oper->level, suspend);
	          send_to_server(":%s NOTICE %s : LastSeen:  %s\n", bot.nick, nwho, get_time(oper->lastseen));
               }
	       sbuff[0] = '\0';
	       buff[0] = '\0';
	       howmany++;
	       addr = oper->adderhead;
	       while(addr != NULL)
	       {
		  sprintf(sbuff, "%s  ", addr->address);
		  strcat(buff, sbuff);
		  addr = addr->next;
	       }
               if(colorm)
	          send_to_server(":%s NOTICE %s : \0031Masks:\003\0032 %s\003\n", bot.nick, nwho, buff);
               else
	          send_to_server(":%s NOTICE %s : Masks: %s\n", bot.nick, nwho, buff);
	       send_to_server(":%s NOTICE %s : -\n", bot.nick, nwho);
	       break;
	    }
	    addr = addr->next;
	 }
      }
      oper = oper->next;
   }
   return;
}
